module chain_mask_lrt

  use weighthrt
  use linearsimp_mod
  use chain_mod_hrt

  implicit none

contains

  integer function chain_mask_lrt_lop(adj, add, model, data)  
    logical            :: adj,add
    real, dimension(:) :: model, data
    real, dimension(:),allocatable :: tmp

    allocate(tmp(size(data)))

    call chain2(weight_lop,linearsimp_lop,adj,add,model,data,tmp)
    
    deallocate(tmp)
    
    chain_mask_lrt_lop=0
    
  end function chain_mask_lrt_lop
  
end module chain_mask_lrt
