module mask_mod
  use adj_mod
  implicit none 
  
contains
  
  integer function masktop_lop( adj, add, model, data,nm)
    logical            ::    adj, add
    real, dimension(:) ::              model, data
    integer            ::                             nm
    call adjnull (adj,add,model,data)
    call masktop_lop2(adj,add,model,data)
    masktop_lop = 0
  end function masktop_lop
  
  integer function maskbot_lop( adj, add, model, data,nm)
    logical            ::    adj, add
    real, dimension(:) ::              model, data
    integer            ::                             nm
    call adjnull (adj,add,model,data)
    call maskbot_lop2(adj,add,model,data)
    maskbot_lop = 0
  end function maskbot_lop

  subroutine masktop_lop2( adj, add, model, data,nm)
    logical           ::adj, add
    real, dimension(:)::          model, data
    integer            ::                        nm
    if (adj) then  
       model(1:nm) = model(1:nm) + data (1:nm)    
    else 
       data (1:nm) = data (1:nm) + model(1:nm)     
    end if
    
  end subroutine masktop_lop2

  subroutine maskbot_lop2( adj, add, model, data,nm)
    logical           ::adj, add
    real, dimension(:)::          model, data
    integer            ::                        nm
    integer:: bm
    bm=size(model)
    if (adj) then 
       model(nm+1:bm) = model(nm+1:bm) + data (nm+1:bm)    
    else 
       data (nm+1:bm) = data (nm+1:bm) + model(nm+1:bm)     
    end if
    
  end subroutine maskbot_lop2

end module identity_mod

