module identity_mod_dp
  use adj_mod_dp
  implicit none 
!  INTEGER, PARAMETER      :: dbl = SELECTED_REAL_KIND(15,307)

contains
  
  integer function identity_lop( adj, add, model, data)
    logical,intent(in) ::        adj, add
    real(kind=8), dimension(:) ::                  model, data
    call adjnull (adj,add,model,data)
    call identity_lop2(adj,add,model,data)
    identity_lop = 0
  end function identity_lop
  
  subroutine identity_lop2( adj, add, model, data)
    logical           ::    adj, add
    real(kind=8), dimension(:)::              model, data

    if (adj) then       
       model = model + data    
    else       
       data  = data + model      
    end if
    
  end subroutine identity_lop2

end module identity_mod_dp

